/**
 * ORY Keto
 * A cloud native access control server providing best-practice patterns (RBAC, ABAC, ACL, AWS IAM Policies, Kubernetes Roles, ...) via REST APIs.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.sh
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OryKeto) {
      root.OryKeto = {};
    }
    root.OryKeto.RemoveOryAccessControlPolicyRoleMembers = factory(root.OryKeto.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The RemoveOryAccessControlPolicyRoleMembers model module.
   * @module model/RemoveOryAccessControlPolicyRoleMembers
   * @version Latest
   */

  /**
   * Constructs a new <code>RemoveOryAccessControlPolicyRoleMembers</code>.
   * RemoveOryAccessControlPolicyRoleMembers remove ory access control policy role members
   * @alias module:model/RemoveOryAccessControlPolicyRoleMembers
   * @class
   * @param flavor {String} The ORY Access Control Policy flavor. Can be \"regex\", \"glob\", and \"exact\".  in: path
   * @param id {String} The ID of the ORY Access Control Policy Role.  in: path
   * @param member {String} The member to be removed.  in: path
   */
  var exports = function(flavor, id, member) {
    var _this = this;

    _this['flavor'] = flavor;
    _this['id'] = id;
    _this['member'] = member;
  };

  /**
   * Constructs a <code>RemoveOryAccessControlPolicyRoleMembers</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RemoveOryAccessControlPolicyRoleMembers} obj Optional instance to populate.
   * @return {module:model/RemoveOryAccessControlPolicyRoleMembers} The populated <code>RemoveOryAccessControlPolicyRoleMembers</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('flavor')) {
        obj['flavor'] = ApiClient.convertToType(data['flavor'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('member')) {
        obj['member'] = ApiClient.convertToType(data['member'], 'String');
      }
    }
    return obj;
  }

  /**
   * The ORY Access Control Policy flavor. Can be \"regex\", \"glob\", and \"exact\".  in: path
   * @member {String} flavor
   */
  exports.prototype['flavor'] = undefined;
  /**
   * The ID of the ORY Access Control Policy Role.  in: path
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * The member to be removed.  in: path
   * @member {String} member
   */
  exports.prototype['member'] = undefined;



  return exports;
}));


